angular.module('beamng.apps')
.directive('adjustableFastMotion', ['bngApi', function (bngApi) {
  return {
	template:
	  '<div class="bngApp">' +
	    '<h2 align="center" id="fastmoCount">1X<h2>' +
	    '<md-slider flex step=1 min=1 max=5 ng-model="slowmoslide" aria-label="_" style="padding: 0 5px"></md-slider>' +
	  '</div>',
    replace: true,
    restrict: 'EA',
	controller: ['$scope', function ($scope) {
		$scope.slowmoslide = 1; //Set initial value to 1X
}],
	
    link: function (scope, element, attrs) {  
	  scope.$watch('slowmoslide', function (newVal, oldVal) {
		  document.getElementById("fastmoCount").innerHTML = newVal + "X";
		  if(newVal == 1){
			  bngApi.engineLua( 'be:setPhysicsSpeedFactor(0)' );
			  bngApi.engineLua( 'extensions.customBullettime.set(1)' );
		  }
		  if(newVal == 2){
			  bngApi.engineLua( 'be:setPhysicsSpeedFactor(1)' );
			  bngApi.engineLua( 'extensions.customBullettime.set(2)' );
		  }
		  if(newVal == 3){
			  bngApi.engineLua( 'be:setPhysicsSpeedFactor(2)' );
			  bngApi.engineLua( 'extensions.customBullettime.set(3)' );
		  }
		  if(newVal == 4){
			  bngApi.engineLua( 'be:setPhysicsSpeedFactor(3)' );
			  bngApi.engineLua( 'extensions.customBullettime.set(4)' );
		  }
		  if(newVal == 5){
			  bngApi.engineLua( 'be:setPhysicsSpeedFactor(4)' );
			  bngApi.engineLua( 'extensions.customBullettime.set(5)' );
		  }
	  });
    }
  };
}]);